Prime Path(素数表+BFS)

Prime Path    POJ-3126

https://cn.vjudge.net/problem/POJ-3126
The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input

3
1033 8179
1373 8017
1033 1033
Sample Output

6
7
0


题目大意

换门牌号,每次只能改变四位数中的任意一位数字,门牌号必须是四位数的素数
问需要变几次才能从n变成m

思路分析

素数表+BFS

代码 :
#include <cstdio>
#include <string.h>
using namespace std;
int f[10000];//素数表,0是素数,1是非素数;
int g[10000];//存遍历点数,0是未搜到的,其余是搜到的,记录的是最早遍历到的时候遍历进行了几次+1
int n,m,ans;
void bl(int n){//向“四周”素数遍历,存在g里面
	int s=n;
	int d=s/1000;
	s=s%1000;
	int c=s/100;
	s=s%100;
	int b=s/10;
	s=s%10;
	int a=s;
	int e=n;
	for(int i=0;i<=9;i++){
		e=d*1000+c*100+b*10+i;
		if(f[e]==0&&g[e]==0)
			g[e]=ans+1;
	}
	e=n;
	for(int i=0;i<=9;i++){
		e=d*1000+c*100+a+i*10;
		if(f[e]==0&&g[e]==0)
			g[e]=ans+1;
	}
	e=n;
	for(int i=0;i<=9;i++){
		e=d*1000+b*10+a+i*100;
		if(f[e]==0&&g[e]==0)
			g[e]=ans+1;
	}
	e=n;
	for(int i=0;i<=9;i++){
		e=c*100+b*10+a+i*1000;
		if(f[e]==0&&g[e]==0)
			g[e]=ans+1;
	}
}
int bfs(){//不断遍历,一直到找到m
	if(g[m]!=0){
		return ans;
	}
	ans++;
	for(int i=1000;i<10000;i++){
		if(g[i]==ans){
			bl(i);
		}
	}
	bfs();
}
int main() {
	for(int i=2;i<10000;i++){//打素数表
		for(int j=i+i;j<10000;j+=i){
			f[j]=1;
		}
	}
	int s;
	scanf("%d", &s);
	while(s--){
		ans=0;
		memset(g,0,sizeof(g));
		scanf("%d %d", &n, &m);
		g[n]=1;
		printf("%d\n",bfs());
	}
	return 0;
}

猜你喜欢

转载自blog.csdn.net/weixin_44410512/article/details/86690990